using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace shipping_starter
{
	/// <summary>
	/// Default is the main form for the shipping_starter application
	/// </summary>
	public class Default : System.Web.UI.Page
	{
		#region Web Form Designer generated code
		protected System.Web.UI.WebControls.Button showAllButton;
		protected System.Web.UI.WebControls.Button showDueTodayButton;
		protected System.Web.UI.WebControls.PlaceHolder showByWeightError;
		protected System.Web.UI.WebControls.TextBox showByWeightTextBox;
		protected System.Web.UI.WebControls.Button showByWeightButton;
		protected System.Web.UI.WebControls.Button showVendorButton;
		protected System.Web.UI.WebControls.PlaceHolder calculateShippingError;
		protected System.Web.UI.WebControls.TextBox distance;
		protected System.Web.UI.WebControls.TextBox weight;
		protected System.Web.UI.WebControls.TextBox items;
		protected System.Web.UI.WebControls.Button calculateShippingButton;
		protected System.Web.UI.WebControls.Repeater results;
		protected System.Web.UI.WebControls.DropDownList showVendorDropDown;
		#endregion

		/// <summary>
		/// Called when page initially loads 
		/// </summary>
		private void Page_Load(object sender, System.EventArgs e)
		{
			/* ... maybe set up your database connection or something ... */

			// set all error messages to invisible, if there is an error they will be reset
			this.showByWeightError.Visible = false;
			this.calculateShippingError.Visible = false;

			// If the page is being requested for the first time, show all 
			if(!Page.IsPostBack)
			{
				ShowAll(null, null);
			}
		}

		/// <summary>
		/// Called before the page is rendered
		/// </summary>
		private void Page_PreRender(object sender, System.EventArgs e)
		{
			// When the page is databound, then all 'templates' are filled out and its safe to
			// clean up the business logic
			DataBind();

			/* ... maybe do some cleanup work here ... */
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		/// <summary>
		/// Show all packages in database
		/// </summary>
		protected void ShowAll(object sender, System.EventArgs e)
		{
			/* !!! */
		}

		/// <summary>
		/// Show all packages due to be delivered today
		/// </summary>
		protected void ShowDueToday(object sender, System.EventArgs e)
		{
			/* !!! */
		}
		
		/// <summary>
		/// Show all packages with that weigh at least x
		/// </summary>
		protected void ShowByWeight(object sender, System.EventArgs e)
		{
			int minWeight = 0;
			// validate user input
			try 
			{
				minWeight = Int32.Parse(this.showByWeightTextBox.Text);
			} 
			catch (FormatException )
			{
				// user input is invalid, return
				this.showByWeightError.Visible = true;
				return;
			}

			/* !!! */
		}
		
		/// <summary>
		/// Show all packages shipped using a given vendor
		/// </summary>
		protected void ShowVendor(object sender, System.EventArgs e)
		{
			int vendorID = 0;
			// validate user input
			try 
			{
				vendorID = Int32.Parse(this.showVendorDropDown.SelectedValue);
			} 
			catch (FormatException )
			{
				// user input is invalid, return
				throw new ApplicationException("Invalid Vendor ID");
				return;
			}

			
			/* !!! */
		}
		
		/// <summary>
		/// Forward user to shipping calculator page.
		/// </summary>
		protected void CalculateShipping(object sender, System.EventArgs e)
		{
			int weight = 0;
			int distance = 0;
			int items = 0;
			// validate user input
			try 
			{
				weight = Int32.Parse(this.weight.Text);
				distance = Int32.Parse(this.distance.Text);
				items = Int32.Parse(this.items.Text);
			} 
			catch (FormatException )
			{
				// user input is invalid, return
				this.calculateShippingError.Visible = true;
				return;
			}

			// Redirect User's Browser
			Response.Redirect("calculator.aspx?weight=" + this.weight.Text + "&distance=" + this.distance.Text + "&items=" + items);
		}
	}
}
